Name:       fbterm
Version:    1.6
Release:    3%{?dist}
License:    GPLv2+
Group:      Applications/System
URL:        http://code.google.com/p/fbterm/
Source0:    http://fbterm.googlecode.com/files/%{name}-%{version}.tar.gz
#Patch0:    %{name}-1.2-kernel-header.patch
#Patch1:    %{name}-1.3-setcap.patch
#Patch2:    %{name}-1.4-iminput.patch
Patch3:    %{name}-1.6-rpmpack.patch
Patch4:    %{name}-1.6-el5.patch
Summary:    A frame-buffer terminal emulator
Summary(zh_CN): 运行在帧缓冲的快速终端仿真器
Summary(zh_TW): 運行在frame-buffer的快速終端模擬機
%define fbterm_rules_name 99-fbterm.rules
%define fbterm_rules_dir %{_sysconfdir}/udev/rules.d
%define fbterm_rules_path %{fbterm_rules_dir}/%{fbterm_rules_name}

BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: autoconf, automake
BuildRequires: fontconfig-devel gpm-devel
Requires: fontconfig

%description
FbTerm is a fast terminal emulator for Linux with frame-buffer device. 
Features include: 
- mostly as fast as terminal of Linux kernel while accelerated scrolling
  is enabled on frame-buffer device 
- select font with fontconfig and draw text with freetype2, same as 
  Qt/Gtk+ based GUI apps 
- dynamically create/destroy up to 10 windows initially running default
  shell 
- record scroll back history for every window 
- auto-detect text encoding with current locale, support double width 
  scripts like  Chinese, Japanese etc 
- switch between configurable additional text encodings with hot keys
  on the fly 
- copy/past selected text between windows with mouse when gpm server 
  is running


%if 0%{?fedora} >= 9
%package udevrules
Group:      Applications/System
Summary:    udev rules that grant regular user access
Requires:   udev

%description udevrules
Regular users might use some applications that require access to frame-buffer device.
For example, ibus-fbterm requires access to /dev/fb0.
This sub-package enables regular user for such access.
%endif

%prep
%setup -q
#%patch0 -p0 -b .kernel-header
#%patch1 -p0 -b .setcap
#%patch2 -p0 -b .iminput
%patch3 -p0 -b .rpmpack
%if 0%{?fedora} >= 9
%else
%patch4 -p0 -b .el5
%endif

%build
autoreconf -iv
%configure --disable-static --disable-rpath
make %{?_smp_mflags}

%install
%__rm -rf $RPM_BUILD_ROOT
%__make DESTDIR=${RPM_BUILD_ROOT} install
%__chmod 755 $RPM_BUILD_ROOT/%{_bindir}/%{name}
%if 0%{?fedora} >= 9
%__mkdir -p $RPM_BUILD_ROOT/%{fbterm_rules_dir}
%__cat >>$RPM_BUILD_ROOT/%{fbterm_rules_path} <<EOF
KERNEL=="fb[0-9]*", SUBSYSTEM=="graphics", MODE="0666"
EOF
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if 0%{?fedora} >= 9
%post
setcap 'cap_sys_tty_config+ep' %{_bindir}/%{name}
%endif

%files 
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog COPYING README
%if 0%{?fedora} >= 9
%{_bindir}/%{name}
%else
%attr(4755,root,root) %{_bindir}/%{name}
%endif
%{_mandir}/man1/%{name}.1.gz

%if 0%{?fedora} >= 9
%files udevrules
%defattr(-,root,root,-)
%config(noreplace) %{fbterm_rules_path}
%endif


%changelog
* Wed Feb 24 2010 Ding-Yi Chen <dchen at redhat dot com> - 1.6-3
- Resolves: #565710
  Add udevrules sub package for installing udev rules for granting regular user access.

* Mon Nov 30 2009 Ding-Yi Chen <dchen at redhat dot com> - 1.6-1
- Fixed [Bug 539186] FTBFS fbterm-1.5-2.fc12
- Upstream fixed [Bug 542284] terminfo file for fbterm not included with fbterm package in fedora.
- Patch for EL-5
- Upstream update:
  1. added VESA video card support 
  2. added rendering messages for IM server development 
  3. fixed a bug where Ctrl+Space is a shortcut even user run FbTerm without "input-method" option 
  4. fixed a bug where user compile FbTerm without gpm mouse support but run it in a gpm server enabled environment 
  5. fixed a IM program dead loop bug triggered by FbTerm's crash 
  6. fixed several spelling errors in FbTerm's help message and man-page

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Fri May 15 2009 Ding-Yi Chen <dchen at redhat dot com> - 1.5-1
- Upstream update:  
  1. added support for text rendering with backround image 
  2. added command-line arguments to customize command executed in sub-window 
  3. added Alt-Fn and all FbTerm's shortcuts support when input method is actived 
  4. added option "-v/--verbose" to show some useful information 
  5. fixed some text color issues with version 1.4 
  6. fixed encoding selection error when locale is C/POSIX 
  7. fixed a bug where screen is cleared on startup even in inactive tty 
  8. fixed a bug where variable HOME is not defined
- rpmpack.patch is to allow rpm buildable for non-root account.
- Add BuildRequires automake, autoconf to "refresh" src/Makefile,
  otherwise, the above patch is not effective for a weird reason.

* Mon Mar 23 2009 Ding-Yi Chen <dchen at redhat dot com> - 1.4-1
- Upstream update:
  1. improved text rendering performence 
  2. added private escape sequences for 256 color mode support 
  3. added a option "font-width" to adjust character cell width 
  4. added support for older 2.2/2.4 kernel 
  5. fixed a crash bug with bitmap fonts 
  6. fixed a configure failure in cross-compiling environment
- Note: iminput.patch is applied.

* Tue Feb 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild
  
* Tue Jan 06 2009 Ding-Yi Chen <dchen at redhat dot com> - 1.3-1
- SUID fbterm for el5, as it does not have libcap.

* Mon Jan 05 2009 Ding-Yi Chen <dchen at redhat dot com> - 1.3-0
- Upstream update:
  1. added command line arguments to change option values 
  2. added client-server based input method framework 
  3. added screen rotation support 
  4. added support for visual type DIRECTCOLOR used by ATI cards 
     (thanks for Witek's patch) 
  5. fixed a bug that user can't input some unicode characters 
  6. fixed a bug of maybe not restore original console state after 
     FbTerm exited 
  7. fixed several trivial bugs 
  8. added using filesystem capability attributes offered by kernel 
     2.6.27, instead of setting set-user-ID bit on FbTerm 
  9. decreased memory usage of every shell instance by changing size 
      of the struct saving every charater's attribute from 4 to 2 bytes

* Thu Dec 11 2008 Ding-Yi Chen <dchen at redhat dot com> - 1.2-2
- Summary simplified.

* Fri Nov 21 2008 Ding-Yi Chen <dchen at redhat dot com> - 1.2-2
- Upstream update, see 
 http://code.google.com/p/fbterm/
 for details.

* Fri Oct 16 2008 Ding-Yi Chen <dchen at redhat dot com> - 1.1-3
- Add gpm support.

* Thu Oct 16 2008 Ding-Yi Chen <dchen at redhat dot com> - 1.1-2
- Fix the kernel-header build problem in F-10.

* Thu Aug 07 2008 Ding-Yi Chen <dchen at redhat dot com> - 1.1-1
- Unset the SUID flag, as it does not need it.

* Thu Aug 07 2008 Ding-Yi Chen <dchen at redhat dot com> - 1.1-0
- The first version.
